"use strict";

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var generateReference = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
    var _this = this;

    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            return _context2.delegateYield(_regenerator2.default.mark(function _callee() {
              var cwd, pkgJson, projectSuffix, destFileLocation, mainFileLocation, basePath, mainFileRelativeWithoutExt, destFileRelativeWithoutExt, dtsGlobPath, pathes, filteredPath, i, jsFiles, _pathes, _filteredPath, _i;

              return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      cwd = process.cwd(); // current working directory

                      _context.t0 = JSON;
                      _context.next = 4;
                      return (0, _asyncHelper.readFileAsync)(_path2.default.join(cwd, "package.json"));

                    case 4:
                      _context.t1 = _context.sent;
                      pkgJson = _context.t0.parse.call(_context.t0, _context.t1);
                      projectSuffix = (0, _common.getSuffix)(pkgJson.name);
                      destFileLocation = _path2.default.resolve(_path2.default.join(cwd, _yargs.argv.dest));
                      mainFileLocation = _path2.default.resolve(_path2.default.join(cwd, _yargs.argv.main));
                      basePath = _path2.default.join(cwd, _yargs.argv.src); // absolute path of source directory

                      mainFileRelativeWithoutExt = _path2.default.relative(basePath, mainFileLocation).replace(/\.ts|\.js/, "");
                      destFileRelativeWithoutExt = _path2.default.relative(basePath, destFileLocation).replace(/\.ts|\.js/, "");

                      if (!_yargs.argv.ts) {
                        _context.next = 32;
                        break;
                      }

                      // Typescript
                      dtsGlobPath = _path2.default.join(cwd, _yargs.argv.dts, "**/*.d.ts");
                      _context.next = 16;
                      return (0, _asyncHelper.globAsync)(dtsGlobPath);

                    case 16:
                      pathes = _context.sent;
                      filteredPath = pathes.map(function (p) {
                        return _path2.default.relative(_path2.default.resolve(cwd, _yargs.argv.dts), p);
                      }).map(function (p) {
                        return p.replace(/\.d\.ts$/, "");
                      }).filter(function (f) {
                        return f !== mainFileRelativeWithoutExt;
                      });

                      if (_yargs.argv.debug) {
                        console.log(_chalk2.default.cyan("Filtered js generation path:\n" + filteredPath));
                      }
                      i = 0;

                    case 20:
                      if (!(i < filteredPath.length)) {
                        _context.next = 30;
                        break;
                      }

                      if (!(filteredPath[i] === destFileRelativeWithoutExt)) {
                        _context.next = 25;
                        break;
                      }

                      _context.next = 24;
                      return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, filteredPath[i] + ".js"), genRefCode([], projectSuffix));

                    case 24:
                      return _context.abrupt("continue", 27);

                    case 25:
                      _context.next = 27;
                      return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, filteredPath[i] + ".js"), genRefCode(filteredPath[i].split(_path2.default.sep), projectSuffix));

                    case 27:
                      i++;
                      _context.next = 20;
                      break;

                    case 30:
                      _context.next = 53;
                      break;

                    case 32:
                      jsFiles = _path2.default.join(cwd, _yargs.argv.src, "**/*.js");
                      _context.next = 35;
                      return (0, _asyncHelper.globAsync)(jsFiles);

                    case 35:
                      _pathes = _context.sent;
                      _filteredPath = _pathes.map(function (p) {
                        return _path2.default.relative(_path2.default.resolve(cwd, _yargs.argv.src), p);
                      }).map(function (p) {
                        return p.replace(/\.js$/, "");
                      }).filter(function (f) {
                        return f !== mainFileRelativeWithoutExt;
                      });

                      if (_yargs.argv.debug) {
                        console.log(_chalk2.default.cyan("Filtered js generation path:\n" + _filteredPath));
                      }
                      _i = 0;

                    case 39:
                      if (!(_i < _filteredPath.length)) {
                        _context.next = 53;
                        break;
                      }

                      if (!(_filteredPath[_i] === destFileRelativeWithoutExt)) {
                        _context.next = 46;
                        break;
                      }

                      _context.next = 43;
                      return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, _filteredPath[_i] + ".js"), genRefCode([], projectSuffix));

                    case 43:
                      _context.next = 45;
                      return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, _filteredPath[_i] + ".d.ts"), genDtsCode(true));

                    case 45:
                      return _context.abrupt("continue", 50);

                    case 46:
                      _context.next = 48;
                      return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, _filteredPath[_i] + ".js"), genRefCode(_filteredPath[_i].split(_path2.default.sep), projectSuffix));

                    case 48:
                      _context.next = 50;
                      return (0, _asyncHelper.writeFileAsync)(_path2.default.join(cwd, _yargs.argv.dts, _filteredPath[_i] + ".d.ts"), genDtsCode(false));

                    case 50:
                      _i++;
                      _context.next = 39;
                      break;

                    case 53:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee, _this);
            })(), "t0", 2);

          case 2:
            _context2.next = 7;
            break;

          case 4:
            _context2.prev = 4;
            _context2.t1 = _context2["catch"](0);

            console.log(_context2.t1);

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this, [[0, 4]]);
  }));

  return function generateReference() {
    return _ref.apply(this, arguments);
  };
}();

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _asyncHelper = require("../async-helper");

var _yargs = require("yargs");

var _common = require("./common");

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function genRefCode(separatedPath, libSuffix) {
  var refCode = "\tObject.defineProperty(exports, \"__esModule\", {\n\t    value: true\n\t});";
  if (!_yargs.argv.core) {
    refCode += "exports.default=window.GrimoireJS.lib." + libSuffix;
  } else {
    refCode += "exports.default=window.GrimoireJS";
  }
  for (var i = 0; i < separatedPath.length; i++) {
    refCode += "." + separatedPath[i];
  }
  return refCode + ";";
}

function genDtsCode(isIndex) {
  if (isIndex) {
    return "declare var __PACKAGE_DECL__:{\n        __VERSION__:string;\n        __NAME__:string;\n        [key:string]:any;\n      };\nexport default __PACKAGE_DECL__;";
  } else {
    return "declare var __MODULE_DECL__:any;\n  export default __MODULE_DECL__;";
  }
}

generateReference();